local GloriousDrops = CreateFrame("frame")
local GloriousVer = "0.6a"
local ScanTip = CreateFrame("GameTooltip", "ScanTip", nil, "GameTooltipTemplate")
ScanTip:SetOwner(WorldFrame, "ANCHOR_NONE" )
local pdesc, tdesc = ""

-- Mob Drops --
local drops = {
	["Aethis"] = 87649,
	["Ahone the Wanderer"] = 86588,
	["Ai-Li Skymirror"] = 86589,
	["Ai-Ran the Shifting Cloud"] = 86590,
	["Arness the Scale"] = 90723,
	["Blackhoof"] = 86565,
	["Bonobos"] = 86591,
	["Borginn Darkfist"] = 86570,
	["Dak the Breaker"] = 86567,
	["Eshelon"] = 87222,
	["Ferdinand"] = 87652,
	["Gaarn the Toxic"] = 90725,
	["Gar'lok"] = 86578,
	["Go-Kan"] = 90719,
	["Havak"] = 86573,
	["Ik-Ik the Nimble"] = 86593,
	["Jonn-Dar"] = 86572,
	["Kah'tir"] = 87218,
	["Kal'tik the Blight"] = 86579,
	["Kang the Soul Thief"] = 86571,
	["Karr the Darkener"] = 86564,
	["Korda Torros"] = 86566,
	["Kor'nas Nightsavage"] = 87642,
	["Krax'ik"] = 87646,
	["Krol the Blade"] = 86574,
	["Lith'ik the Stalker"] = 87221,
	["Lon the Bull"] = 87219,
	["Major Nanners"] = 86594,
	["Mister Ferocious"] = 87652,
	["Moldo One-Eye"] = 86586,
	["Morgrinn Crackfang"] = 87643,
	["Nalash Verdantis"] = 86563,
	["Nal'lak the Ripper"] = 86576,
	["Nasra Spothide"] = 86587,
	["Nessos the Oracle"] = 86584,
	["Norlaxx"] = 87220,
	["Norlaxx the Outcast"] = 86581,
	["Omnis Grinlok"] = 86585,
	["Qu'nas"] = 90717,
	["Ruun Ghostpaw"] = 90720,
	["Sahn Tidehunter"] = 86582,
	["Salyin Warscout"] = 86583,
	["Sarnak"] = 87650,
	["Scritch"] = 86592,
	["Sele'na"] = 86580,
	["Siltriss the Sharpener"] = 87223,
	["Ski'thik"] = 86577,
	["Spriggin"] = 90724,
	["Sulik'shor"] = 86569,
	["The Yowler"] = 87225,
	["Torik-Ethis"] = 90722,
	["Urgolax"] = 86575,
	["Urobi the Walker"] = 87651,
	["Yorik Sharpeye"] = 86568,
	["Yul Wildpaw"] = 87224,
    -------------------------
	--5.4 Timeless Champion--
    -------------------------
	["Archiereus of Flame"] = 86574,
	["Bufo"] = 104169,
	["Champion of the Black Flame"] = 104302,
	--["Chelon"] = 0000000,--
	["Cinderfall"] = 104299,
	["Cranegnasher"] = 104268,
	["Dread Ship Vazuvius"] = 104294,
	["Emerald Gander"] = 104287,
	["Evermaw"] = 104115,
	["Flintlord Gairan"] = 104329,
	--["Flintlord Gairan"] = 104298,--
	["Garnia"] = 104159,
	["Golganarr"] = 104262,
	--["Great Turtle Furyshell"] = 0000000,--
	["Gu'chi the Swarmbringer"] = 104291,
	--["Huolon"] = 104286,--
	["Huolon"] = 104269,
	["Ironfur Steelhorn"] = 89770,
	["Imperial Python"] = 104161,
	["Jakur of Ordon"] = 104331,
	["Karkanos"] = 104035,
	["Leafmender"] = 104156,
	["Monstrous Spineclaw"] = 104168,
	["Rattleskew"] = 104321,
	["Rock Moss"] = 104313,
	["Spelurk"] = 104320,
	["Spirit of Jadefire"] = 104258,
	["Tsavo'ka"] = 104268,
	["Urdur the Cauterizer"] = 104306,
	["Watcher Osu"] = 104305,
	["Zesqua"] = 104303,
	["Zhu-Gon the Sour"] = 104167,
    ---------------------
	--5.4 Miscellaneous--
    ---------------------
	["Cursed Hozen Swabby"] = 104038,
	--["Spectral Pirate"] = 0000000,--
	--["Stinkbraid"] = 0000000,--
	["Molten Guardian"] = 104328,
	["Nice Sprite"] = 104160,
	["Angry Sprite"] = 104160,
	["Scary Sprite"] = 104160,
	--["Whizzig"] = 103795,--
	["Whizzig"] = 103786,
	--["Whizzig"] = 103789,--
	--["Whizzig"] = 103797,--
	--["Whizzig"] = 104230,--
	--["Master Kukuru"] = 101538,
	--["Zarhym"] = 0000000,--,
	["Zandalari Warbringer"] = 94229,
    -------------------------
    -- Warlords of Draenor --
    -------------------------
    --  Shadowmoon Valley  --
    -------------------------
    ["Ku'targ the Voidseer"] = 109061,
    ["Leaf-Reader Kurri"] = 108907,
    ["Gorum"] = 113082,
    ["Mother Om'ra"] = 113527,
    ["Windfang Matriarch"] = 113553,
    ["Yggdrel"] = 113570,
    ["Veloss"] = 108906,
    ["Dark Emanation"] = 109075,
    ["Amaukwa"] = 109060,
    ["Mad \"King\" Sporeon"] = 113561,
    ["Hypnocroak"] = 113631,
    ["Bahameye"] = 111666,
    ["Brambleking Fili"] = 117551,
    ["Faebright"] = 113557,
    ["Darkmaster Go'vid"] = 113548,
    ["Ba'ruun"] = 113540,
    ["Morva Soultwister"] = 113559,
    ["Rai'vosh"] = 113542,
    ["Darktalon"] = 113541,
    ["Shinri"] = 113543,
    ["Enavra"] = 113556,
    ["Voidseer Kalurg"] = 109074,
    ["Insha'tar"] = 113571,
    ["Demidos"] = 823,
    --["Quartermaster Hershak"] = 823, Apexis Crystals
    ["Master Sergeant Milgra"] = 119368,
    --["Shadowspeaker Niir"] = 823, Apexis Crystals
    ["Voidreaver Urnae"] = 119392,
    ["Lady Temptessa"] = 119360,
    ["Malgosh Shadowkeeper"] = 119369,
    --["Avalanche"] = 823, Apexis Crystals
    ["Aqualir"] = 119387,
    ["Sneevel"] = 118734,
    -------------------------
    --   Frostfire Ridge   --
    -------------------------
    ["Giant-Slayer Kul"] = 111530,
    ["Canyon Icemother"] = 101436,
    ["Cindermaw"] = 111490,
    ["Broodmother Reeg'ak"] = 111533,
    ["Firefury Giant"] = 107661,
    ["Coldtusk"] = 111484,
    ["Primalist Mur'og"] = 111576,
    ["Coldstomp the Griever"] = 112066,
    ["Scout Goreseeker"] = 112094,
    ["The Beater"] = 111475,
    --["Huntmaster Kuang"] = 824, Garrison Resources
    ["The Bone Crawler"] = 111534,
    ["Pale Fishmonger"] = 111666,
    ["Cyclonic Fury"] = 112086,
    ["Breathless"] = 111476,
    --["Ug'lok the Frozen"] = 823, Apexis Crystals
    ["Yaga the Scarred"] = 111477,
    ["Gruuk"] = 111948,
    ["Gurun"] = 111955,
    ["Chillfang"] = 111953,
    ["Grutush the Pillager"] = 112077,
    ["Jabberjaw"] = 119390,
    ["Tor'goroth"] = 119379,
    ["Son of Goramal"] = 119399,
    --["Kaga the Ironbender"] = 823, Apexis Crystals
    --["Ak'ox the Slaughterer"] = 823, Apexis Crystals
    --["Taskmaster Kullah"] = 000000,
    ["Ragore Driftstalker"] = 119359,
    --["Hoarfrost"] = 823, Apexis Crystals
    --["Vrok the Ancient"] = 823, Apexis Crystals
    --["Valkor"] = 823, Apexis Crystals
    --["Jaluk the Pacifist"] = 823, Apexis Crystals
    --["Ogom the Mangler"] = 823, Apexis Crystals
    -------------------------
    --      Gorgrond       --
    -------------------------
    ["Mother Araneae"] = 118208,
    ["Gnarljaw"] = 119397,
    ["Stomper Kreego"] = 118224,
    ["Sulfurious"] = 114227,
    ["Glut"] = 118229,
    ["Gelgor of the Blue Flame"] = 118230,
    ["Bashiok"] = 118222,
    ["Char the Burning"] = 118212,
    ["Hive Queen Skrikka"] = 118209,
    ["Mandrakor"] = 118709,
    ["Greldrok the Cunning"] = 118210,
    ["Fossilwood the Petrified"] = 118221,
    ["Sunclaw"] = 118223,
    ["Basten"] = 119432,
    --["Nultra"] = 000000,
    --["Valstil"] = 000000,
    --["Alkali"] = 823, Apexis Crystals
    ["Stompalupagus"] = 118228,
    --["Maniacal Madgard"] = 000000,
    --["Defector Dazgo"] = 000000,
    --["Durp the Hated"] = 000000,
    --["Inventor Blammo"] = 000000,
    --["Blademaster Ro'gor"] = 000000,
    --["Firestarter Grash"] = 000000,
    ["Swift Onyx Flayer"] = 119367,
    ["Grove Warden Yal"] = 119414,
    ["Hunter Bal'ra"] = 119412,
    -------------------------
    --       Talador       --
    -------------------------
    ["Isaari"] = 117563,
    ["Yazheera the Incinerator"] = 112263,
    ["Dr. Gloom"] = 112499,
    ["Frenzied Golem"] = 113288,
    ["Cro Fleshrender"] = 116123,
    ["Hen-Mother Hami"] = 112369,
    ["Hammertooth"] = 116124,
    ["Glimmerwing"] = 116113,
    ["Ra'kahn"] = 116112,
    ["Wandering Vindicator"] = 112261,
    ["Lo'marg Jawcrusher"] = 116070,
    ["Echo of Murmur"] = 113670,
    ["Kharazos the Triumphant"] = 116122,
    ["Galzomar"] = 116122,
    ["Sikthiss, Maiden of Slaughter"] = 116122,
    ["Klikixx"] = 116125,
    ["No'losh"] = 116077,
    --["Kurlosh Doomfang"] = 823, Apexis Crystals
    --["Lady Demlash"] = 823, Apexis Crystals
    ["Talonpriest Zorkra"] = 116110,
    ["Shirzir"] = 112370,
    ["Felbark"] = 112373,
    ["Gennadian"] = 116075,
    ["Xothear, the Destroyer"] = 119435,
    ["Felfire Consort"] = 119386,
    ["Matron of Sin"] = 119353,
    ["Haakun the All-Consuming"] = 119403,
    ["Gug'tol"] = 119402,
    --["Grrbrrgle"] = 000000,
    ["Steeltusk"] = 117562,
    ["Avatar of Socrethar"] = 119378,
    --["Strategist Ankor"] = 823, Apexis Crystals
    --["Legion Vanguard"] = 823, Apexis Crystals
    ["Soulbinder Naylana"] = 119350,
    -------------------------
    --    Spires of Arak   --
    -------------------------
    ["Shadowbark"] = 118201,
    ["Blade-Dancer Aeryx"] = 116839,
    ["Nas Dunberlin"] = 116837,
    --["Solar Magnifier"] = 000000,
    ["Mutafen"] = 118206,
    ["Tesska the Broken"] = 116852,
    ["Stonespite"] = 116858,
    ["Durkath Steelmaw"] = 118198,
    ["Kalos the Bloodbathed"] = 118735,
    ["Sangrikass"] = 118203,
    ["Talonbreaker"] = 116838,
    ["Poisonmaster Bortusk"] = 118199,
    ["Blightglow"] = 118205,
    ["Oskiira the Vengeful"] = 118204,
    ["Betsi Boombasket"] = 116907,
    ["Festerbloom"] = 118200,
    ["Sunderthorn"] = 116855,
    ["Jiasska the Sporegorger"] = 118202,
    ["Rotcap"] = 118107,
    ["Swarmleaf"] = 116857,
    ["Hermit Palefur"] = 118279,
    --["Gaze"] = 000000,
    --["Gluttonous Giant"] = 000000,
    --["Shadow Hulk"] = 823, Apexis Crystals
    -------------------------
    --       Nagrand       --
    -------------------------
    ["Hyperious"] = 116799,
    ["Warmaster Blugthol"] = 116805,
    ["Captain Ironbeard"] = 118244,
    --["Captain Ironbeard"] = 116809, 2nd Drop Item
    ["Soulfang"] = 116806,
    ["Explorer Nozzand"] = 118679,
    ["Redclaw the Feral"] = 118243,
    ["Greatfeather"] = 116795,
    ["Gar'lua"] = 118246,
    ["Gnarlhoof the Rabid"] = 116824,
    --["Ancient Blademaster"] = 824, Garrison Resources
    ["Grizzlemaw"] = 118687,
    ["Fangler"] = 116836,
    ["Netherspawn"] = 116815,
    ["Ophiis"] = 116765,
    ["Windcaller Korast"] = 116808,
    ["Flinthide"] = 116807,
    ["Gorepetal"] = 116916,
    --["Ru'klaa"] = 824, Garrison Resources
    --["Sean Whitesea"] = 824, Garrison Resources
    ["Tura'aka"] = 116814,
    ["Hunter Blacktooth"] = 118245,
    ["Scout Pokhar"] = 116797,
    ["Malroc Stonesunder"] = 116796,
    ["Outrider Duretha"] = 116800,
    ["Graveltooth"] = 118689,
    ["Mr. Pinchy Sr."] = 118690,
    ["Bergruu"] = 118655,
    ["Dekorhan"] = 118656,
    ["Thek'talon"] = 118660,
    ["Gagrog the Brutal"] = 118658,
    ["Xelganak"] = 118661,
    ["Karosh Blackwind"] = 119355,
    ["Brutag Grimblade"] = 119380,
    ["Durg Spinecrusher"] = 119405,
    --["Pit Beast"] = 823, Apexis Crystals
    -------------------------
    -- Draenor Mount Drops --
    -------------------------
    ["Pathrunner"] = 116773,
    ["Gorok"] = 116674,
    ["Nok-Karosh"] = 116794,
    ["Poundfist"] = 116792,
    ["Silthide"] = 116767,
    ["Luk'hok"] = 116661,
    ["Nakk the Thunderer"] = 116659,
}
-- 2nd Mob Drops --
local drops_second = {
    ["Frenzied Golem"] = 113287,
    ["Captain Ironbeard"] = 116809,
}
--http://www.wowhead.com/news=244136/warlords-of-draenor-guides-to-rare-spawns-and-treasures-november-3rd-hotfixes-en

-- Start the Magic
DEFAULT_CHAT_FRAME:AddMessage("|cFFFF7F00Glorious Drops v"..GloriousVer.." Loaded")

function GloriousDrops:GET_ITEM_INFO_RECEIVED(event, addon)
	GDrops()
end

function GDrops()
	local unitName, unitInfo = GameTooltip:GetUnit()

	if drops[unitName] then
        GloriousDrops:RegisterEvent("GET_ITEM_INFO_RECEIVED")
        local name, t, quality, t, t, t, t, t, t, texture = GetItemInfo(drops[unitName])
        if not quality then
            return
        end
        GloriousDrops:UnregisterEvent("GET_ITEM_INFO_RECEIVED")
        local r, g, b, hex = GetItemQualityColor(quality)

        ScanTip:ClearLines()
        ScanTip:SetItemByID(drops[unitName])

        GameTooltip:AddLine("\nGlorious Drops\n", 1, 0.5, 0)
        GameTooltip:AddDoubleLine(name, "|T" .. texture .. ":22|t", r, g, b)

        for i=2,ScanTip:NumLines() do
            local myLeft=_G["ScanTipTextLeft"..i]
            local txtLeft=myLeft:GetText()
            local myRight=_G["ScanTipTextRight"..i]
            local txtRight=myRight:GetText()
            if (txtRight) then
                GameTooltip:AddDoubleLine(txtLeft, txtRight, 1, 1, 1, 1, 1, 1)
            else
                if string.find(txtLeft, "Use:", 1) then
                    GameTooltip:AddLine(txtLeft, 0, 1, 0, true)
                elseif string.find(txtLeft, "Equip:", 1) then
                    GameTooltip:AddLine(txtLeft, 0, 1, 0, true)
                elseif string.find(txtLeft, "<Right", 1) then
                    GameTooltip:AddLine(txtLeft, 0, 1, 0, true)
                elseif string.find(txtLeft, '"', 1) then
                    GameTooltip:AddLine(txtLeft, 1, 1, 0, true)
                else
                    GameTooltip:AddLine(txtLeft, 1, 1, 1, true)
                end
            end
        end
    end
    if drops_second[unitName] then
        GloriousDrops:RegisterEvent("GET_ITEM_INFO_RECEIVED")
        local name, t, quality, t, t, t, t, t, t, texture = GetItemInfo(drops_second[unitName])
        if not quality then
            return
        end
        GloriousDrops:UnregisterEvent("GET_ITEM_INFO_RECEIVED")
        local r, g, b, hex = GetItemQualityColor(quality)

        ScanTip:ClearLines()
        ScanTip:SetItemByID(drops_second[unitName])

        GameTooltip:AddLine("\nGlorious Drops\n", 1, 0.5, 0)
        GameTooltip:AddDoubleLine(name, "|T" .. texture .. ":22|t", r, g, b)

        for i=2,ScanTip:NumLines() do
            local myLeft=_G["ScanTipTextLeft"..i]
            local txtLeft=myLeft:GetText()
            local myRight=_G["ScanTipTextRight"..i]
            local txtRight=myRight:GetText()
            if (txtRight) then
                GameTooltip:AddDoubleLine(txtLeft, txtRight, 1, 1, 1, 1, 1, 1)
            else
                if string.find(txtLeft, "Use:", 1) then
                    GameTooltip:AddLine(txtLeft, 0, 1, 0, true)
                elseif string.find(txtLeft, "Equip:", 1) then
                    GameTooltip:AddLine(txtLeft, 0, 1, 0, true)
                elseif string.find(txtLeft, "<Right", 1) then
                    GameTooltip:AddLine(txtLeft, 0, 1, 0, true)
                elseif string.find(txtLeft, '"', 1) then
                    GameTooltip:AddLine(txtLeft, 1, 1, 0, true)
                else
                    GameTooltip:AddLine(txtLeft, 1, 1, 1, true)
                end
            end
        end
    end
end

GameTooltip:HookScript("OnTooltipSetUnit", function(self, ...)
	GDrops()
end)